#ifndef EFL_LOOP_TIMER_EO_HH
#define EFL_LOOP_TIMER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_loop.eo.h"
#include "efl_loop_timer.eo.h"
#include "efl_loop_user.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_loop.eo.hh"
#include "efl_loop_user.eo.hh"
#include "eo_base.eo.hh"
namespace efl { namespace loop { 
struct Timer;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::loop::Timer> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace loop { 
struct Timer {
   ::efl::eolian::return_traits<double>::type interval_get() const;
   ::efl::eolian::return_traits<void>::type interval_set( ::efl::eolian::in_traits<double>::type in) const;
   ::efl::eolian::return_traits<double>::type pending_get() const;
   ::efl::eolian::return_traits<void>::type reset() const;
   ::efl::eolian::return_traits<void>::type loop_reset() const;
   ::efl::eolian::return_traits<void>::type delay( ::efl::eolian::in_traits<double>::type add) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_LOOP_TIMER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::loop::Timer() const;
   operator ::efl::loop::Timer&();
   operator ::efl::loop::Timer const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Timer,  ::efl::Loop_User,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Timer const ,  ::efl::Loop_User const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace loop { 
struct Timer : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Loop_User)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Timer( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Timer(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Timer(Timer const& other) = default;
   Timer(Timer&& other) = default;
   Timer& operator=(Timer const& other) = default;
   Timer& operator=(Timer&& other) = default;
   Timer()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Timer( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Timer(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<double>::type interval_get() const;
   ::efl::eolian::return_traits<void>::type interval_set( ::efl::eolian::in_traits<double>::type in) const;
   ::efl::eolian::return_traits<double>::type pending_get() const;
   ::efl::eolian::return_traits<void>::type reset() const;
   ::efl::eolian::return_traits<void>::type loop_reset() const;
   ::efl::eolian::return_traits<void>::type delay( ::efl::eolian::in_traits<double>::type add) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_LOOP_TIMER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct tick_event
   {
      static Eo_Event_Description const* description()
      { return EFL_LOOP_TIMER_EVENT_TICK; }
      typedef void parameter_type;
   } const tick_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Timer,  ::efl::Loop_User,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Timer const ,  ::efl::Loop_User const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Timer) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Timer>::value, "");
} } 
#include "efl_loop_timer.eo.impl.hh"
#endif
