#ifndef EFL_CANVAS_EO_HH
#define EFL_CANVAS_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_canvas.eo.h"
#include "efl_gfx.eo.h"
#include "efl_input_device.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_gfx.eo.hh"
#include "efl_input_device.eo.hh"
namespace efl { 
struct Canvas;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Canvas> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { 
struct Canvas {
   ::efl::eolian::return_traits<void>::type pointer_canvas_xy_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   ::efl::eolian::return_traits<bool>::type pointer_inside_get() const;
   ::efl::eolian::return_traits<bool>::type image_max_size_get( ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
   ::efl::eolian::return_traits<void>::type smart_objects_calculate() const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::Gfx>>::type objects_at_xy_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits< ::efl::Gfx>::type object_top_at_xy_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::Gfx>>::type objects_in_rectangle_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits< ::efl::Gfx>::type object_top_in_rectangle_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Canvas() const;
   operator ::efl::Canvas&();
   operator ::efl::Canvas const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Canvas> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Canvas const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Canvas : ::efl::eo::concrete
{
   explicit Canvas( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Canvas(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Canvas(Canvas const& other) = default;
   Canvas(Canvas&& other) = default;
   Canvas& operator=(Canvas const& other) = default;
   Canvas& operator=(Canvas&& other) = default;
   Canvas()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Canvas( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Canvas(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type pointer_canvas_xy_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   ::efl::eolian::return_traits<bool>::type pointer_inside_get() const;
   ::efl::eolian::return_traits<bool>::type image_max_size_get( ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
   ::efl::eolian::return_traits<void>::type smart_objects_calculate() const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::Gfx>>::type objects_at_xy_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits< ::efl::Gfx>::type object_top_at_xy_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::Gfx>>::type objects_in_rectangle_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits< ::efl::Gfx>::type object_top_in_rectangle_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct focus_in_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_EVENT_FOCUS_IN; }
      typedef void parameter_type;
   } const focus_in_event;
   static struct focus_out_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_EVENT_FOCUS_OUT; }
      typedef void parameter_type;
   } const focus_out_event;
   static struct object_focus_in_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_EVENT_OBJECT_FOCUS_IN; }
      typedef  ::efl::Gfx parameter_type;
   } const object_focus_in_event;
   static struct object_focus_out_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_EVENT_OBJECT_FOCUS_OUT; }
      typedef  ::efl::Gfx parameter_type;
   } const object_focus_out_event;
   static struct render_pre_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_EVENT_RENDER_PRE; }
      typedef void parameter_type;
   } const render_pre_event;
   static struct render_post_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_EVENT_RENDER_POST; }
      typedef void parameter_type;
   } const render_post_event;
   static struct device_changed_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_EVENT_DEVICE_CHANGED; }
      typedef  ::efl::input::Device parameter_type;
   } const device_changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Canvas> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Canvas const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Canvas) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Canvas>::value, "");
} 
#include "efl_canvas.eo.impl.hh"
#endif
