#ifndef EFL_FILE_EO_HH
#define EFL_FILE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_file.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { 
struct File;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::File> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { 
struct File {
   ::efl::eolian::return_traits<void>::type file_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type file,  ::efl::eolian::out_traits< ::efl::eina::string_view>::type key) const;
   ::efl::eolian::return_traits<bool>::type file_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type file,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   ::efl::eolian::return_traits<bool>::type async_get() const;
   ::efl::eolian::return_traits<void>::type async_set( ::efl::eolian::in_traits<bool>::type async) const;
   ::efl::eolian::return_traits<bool>::type save( ::efl::eolian::in_traits< ::efl::eina::string_view>::type file,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type flags) const;
   ::efl::eolian::return_traits<void>::type eject() const;
   ::efl::eolian::return_traits<bool>::type async_wait() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_FILE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::File() const;
   operator ::efl::File&();
   operator ::efl::File const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<File> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<File const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct File : ::efl::eo::concrete
{
   explicit File( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit File(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   File(File const& other) = default;
   File(File&& other) = default;
   File& operator=(File const& other) = default;
   File& operator=(File&& other) = default;
   File()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   File( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> File(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type file_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type file,  ::efl::eolian::out_traits< ::efl::eina::string_view>::type key) const;
   ::efl::eolian::return_traits<bool>::type file_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type file,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   ::efl::eolian::return_traits<bool>::type async_get() const;
   ::efl::eolian::return_traits<void>::type async_set( ::efl::eolian::in_traits<bool>::type async) const;
   ::efl::eolian::return_traits<bool>::type save( ::efl::eolian::in_traits< ::efl::eina::string_view>::type file,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type flags) const;
   ::efl::eolian::return_traits<void>::type eject() const;
   ::efl::eolian::return_traits<bool>::type async_wait() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_FILE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct async_opened_event
   {
      static Eo_Event_Description const* description()
      { return EFL_FILE_EVENT_ASYNC_OPENED; }
      typedef void parameter_type;
   } const async_opened_event;
   static struct async_error_event
   {
      static Eo_Event_Description const* description()
      { return EFL_FILE_EVENT_ASYNC_ERROR; }
      typedef void parameter_type;
   } const async_error_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<File> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<File const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(File) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<File>::value, "");
} 
#include "efl_file.eo.impl.hh"
#endif
