#ifndef EFL_GFX_BUFFER_EO_HH
#define EFL_GFX_BUFFER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_gfx_buffer.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace gfx { 
struct Buffer;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::gfx::Buffer> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace gfx { 
struct Buffer {
   ::efl::eolian::return_traits<void>::type buffer_size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type buffer_size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<Efl_Gfx_Colorspace>::type colorspace_get() const;
   ::efl::eolian::return_traits<bool>::type alpha_get() const;
   ::efl::eolian::return_traits<void>::type alpha_set( ::efl::eolian::in_traits<bool>::type alpha) const;
   ::efl::eolian::return_traits<int>::type stride_get() const;
   ::efl::eolian::return_traits<void>::type buffer_borders_get( ::efl::eolian::out_traits< unsigned int>::type l,  ::efl::eolian::out_traits< unsigned int>::type r,  ::efl::eolian::out_traits< unsigned int>::type t,  ::efl::eolian::out_traits< unsigned int>::type b) const;
   ::efl::eolian::return_traits<void>::type buffer_update_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<void*>::type buffer_map( ::efl::eolian::out_traits<int>::type length,  ::efl::eolian::in_traits<Efl_Gfx_Buffer_Access_Mode>::type mode,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type x,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type y,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type w,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type h,  ::efl::eolian::in_traits< ::efl::eina::optional<Efl_Gfx_Colorspace>>::type cspace,  ::efl::eolian::out_traits<int*>::type stride) const;
   ::efl::eolian::return_traits<bool>::type buffer_unmap( ::efl::eolian::in_traits<void*>::type data,  ::efl::eolian::in_traits<int>::type length) const;
   ::efl::eolian::return_traits<bool>::type buffer_data_set( ::efl::eolian::in_traits<void*>::type pixels,  ::efl::eolian::in_traits<int>::type width,  ::efl::eolian::in_traits<int>::type height,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type stride,  ::efl::eolian::in_traits< ::efl::eina::optional<Efl_Gfx_Colorspace>>::type cspace) const;
   ::efl::eolian::return_traits<bool>::type buffer_copy_set( ::efl::eolian::in_traits<void const*>::type pixels,  ::efl::eolian::in_traits<int>::type width,  ::efl::eolian::in_traits<int>::type height,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type stride,  ::efl::eolian::in_traits< ::efl::eina::optional<Efl_Gfx_Colorspace>>::type cspace) const;
   ::efl::eolian::return_traits<void*>::type buffer_data_get() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_GFX_BUFFER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::gfx::Buffer() const;
   operator ::efl::gfx::Buffer&();
   operator ::efl::gfx::Buffer const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Buffer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Buffer const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace gfx { 
struct Buffer : ::efl::eo::concrete
{
   explicit Buffer( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Buffer(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Buffer(Buffer const& other) = default;
   Buffer(Buffer&& other) = default;
   Buffer& operator=(Buffer const& other) = default;
   Buffer& operator=(Buffer&& other) = default;
   Buffer()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Buffer( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Buffer(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type buffer_size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type buffer_size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<Efl_Gfx_Colorspace>::type colorspace_get() const;
   ::efl::eolian::return_traits<bool>::type alpha_get() const;
   ::efl::eolian::return_traits<void>::type alpha_set( ::efl::eolian::in_traits<bool>::type alpha) const;
   ::efl::eolian::return_traits<int>::type stride_get() const;
   ::efl::eolian::return_traits<void>::type buffer_borders_get( ::efl::eolian::out_traits< unsigned int>::type l,  ::efl::eolian::out_traits< unsigned int>::type r,  ::efl::eolian::out_traits< unsigned int>::type t,  ::efl::eolian::out_traits< unsigned int>::type b) const;
   ::efl::eolian::return_traits<void>::type buffer_update_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<void*>::type buffer_map( ::efl::eolian::out_traits<int>::type length,  ::efl::eolian::in_traits<Efl_Gfx_Buffer_Access_Mode>::type mode,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type x,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type y,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type w,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type h,  ::efl::eolian::in_traits< ::efl::eina::optional<Efl_Gfx_Colorspace>>::type cspace,  ::efl::eolian::out_traits<int*>::type stride) const;
   ::efl::eolian::return_traits<bool>::type buffer_unmap( ::efl::eolian::in_traits<void*>::type data,  ::efl::eolian::in_traits<int>::type length) const;
   ::efl::eolian::return_traits<bool>::type buffer_data_set( ::efl::eolian::in_traits<void*>::type pixels,  ::efl::eolian::in_traits<int>::type width,  ::efl::eolian::in_traits<int>::type height,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type stride,  ::efl::eolian::in_traits< ::efl::eina::optional<Efl_Gfx_Colorspace>>::type cspace) const;
   ::efl::eolian::return_traits<bool>::type buffer_copy_set( ::efl::eolian::in_traits<void const*>::type pixels,  ::efl::eolian::in_traits<int>::type width,  ::efl::eolian::in_traits<int>::type height,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type stride,  ::efl::eolian::in_traits< ::efl::eina::optional<Efl_Gfx_Colorspace>>::type cspace) const;
   ::efl::eolian::return_traits<void*>::type buffer_data_get() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_GFX_BUFFER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Buffer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Buffer const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Buffer) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Buffer>::value, "");
} } 
#include "efl_gfx_buffer.eo.impl.hh"
#endif
