#ifndef EFL_GFX_FILTER_EO_HH
#define EFL_GFX_FILTER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_gfx.eo.h"
#include "efl_gfx_filter.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_gfx.eo.hh"
namespace efl { namespace gfx { 
struct Filter;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::gfx::Filter> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace gfx { 
struct Filter {
   ::efl::eolian::return_traits<void>::type filter_program_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type code,  ::efl::eolian::out_traits< ::efl::eina::string_view*>::type name) const;
   ::efl::eolian::return_traits<void>::type filter_program_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type code,  ::efl::eolian::in_traits< ::efl::eina::optional< ::efl::eina::string_view>>::type name) const;
   ::efl::eolian::return_traits<void>::type filter_state_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type cur_state,  ::efl::eolian::out_traits<double>::type cur_val,  ::efl::eolian::out_traits< ::efl::eina::string_view*>::type next_state,  ::efl::eolian::out_traits<double*>::type next_val,  ::efl::eolian::out_traits<double*>::type pos) const;
   ::efl::eolian::return_traits<void>::type filter_state_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type cur_state,  ::efl::eolian::in_traits<double>::type cur_val,  ::efl::eolian::in_traits< ::efl::eina::optional< ::efl::eina::string_view>>::type next_state,  ::efl::eolian::in_traits< ::efl::eina::optional<double>>::type next_val,  ::efl::eolian::in_traits< ::efl::eina::optional<double>>::type pos) const;
   ::efl::eolian::return_traits<void>::type filter_padding_get( ::efl::eolian::out_traits<int>::type l,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type t,  ::efl::eolian::out_traits<int>::type b) const;
   ::efl::eolian::return_traits< ::efl::Gfx>::type filter_source_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits<void>::type filter_source_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::in_traits< ::efl::Gfx>::type source) const;
   ::efl::eolian::return_traits<void>::type filter_data_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::out_traits< ::efl::eina::string_view>::type value,  ::efl::eolian::out_traits<bool>::type execute) const;
   ::efl::eolian::return_traits<void>::type filter_data_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type value,  ::efl::eolian::in_traits<bool>::type execute) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_GFX_FILTER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::gfx::Filter() const;
   operator ::efl::gfx::Filter&();
   operator ::efl::gfx::Filter const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Filter> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Filter const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace gfx { 
struct Filter : ::efl::eo::concrete
{
   explicit Filter( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Filter(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Filter(Filter const& other) = default;
   Filter(Filter&& other) = default;
   Filter& operator=(Filter const& other) = default;
   Filter& operator=(Filter&& other) = default;
   Filter()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Filter( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Filter(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type filter_program_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type code,  ::efl::eolian::out_traits< ::efl::eina::string_view*>::type name) const;
   ::efl::eolian::return_traits<void>::type filter_program_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type code,  ::efl::eolian::in_traits< ::efl::eina::optional< ::efl::eina::string_view>>::type name) const;
   ::efl::eolian::return_traits<void>::type filter_state_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type cur_state,  ::efl::eolian::out_traits<double>::type cur_val,  ::efl::eolian::out_traits< ::efl::eina::string_view*>::type next_state,  ::efl::eolian::out_traits<double*>::type next_val,  ::efl::eolian::out_traits<double*>::type pos) const;
   ::efl::eolian::return_traits<void>::type filter_state_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type cur_state,  ::efl::eolian::in_traits<double>::type cur_val,  ::efl::eolian::in_traits< ::efl::eina::optional< ::efl::eina::string_view>>::type next_state,  ::efl::eolian::in_traits< ::efl::eina::optional<double>>::type next_val,  ::efl::eolian::in_traits< ::efl::eina::optional<double>>::type pos) const;
   ::efl::eolian::return_traits<void>::type filter_padding_get( ::efl::eolian::out_traits<int>::type l,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type t,  ::efl::eolian::out_traits<int>::type b) const;
   ::efl::eolian::return_traits< ::efl::Gfx>::type filter_source_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits<void>::type filter_source_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::in_traits< ::efl::Gfx>::type source) const;
   ::efl::eolian::return_traits<void>::type filter_data_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::out_traits< ::efl::eina::string_view>::type value,  ::efl::eolian::out_traits<bool>::type execute) const;
   ::efl::eolian::return_traits<void>::type filter_data_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type value,  ::efl::eolian::in_traits<bool>::type execute) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_GFX_FILTER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Filter> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Filter const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Filter) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Filter>::value, "");
} } 
#include "efl_gfx_filter.eo.impl.hh"
#endif
