#ifndef EFL_INPUT_DEVICE_EO_HH
#define EFL_INPUT_DEVICE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_input_device.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "eo_base.eo.hh"
namespace efl { namespace input { 
struct Device;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::input::Device> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace input { 
struct Device {
   ::efl::eolian::return_traits<Efl_Input_Device_Class>::type device_type_get() const;
   ::efl::eolian::return_traits<void>::type device_type_set( ::efl::eolian::in_traits<Efl_Input_Device_Class>::type klass) const;
   ::efl::eolian::return_traits<Efl_Input_Device_Sub_Class>::type device_subtype_get() const;
   ::efl::eolian::return_traits<void>::type device_subtype_set( ::efl::eolian::in_traits<Efl_Input_Device_Sub_Class>::type klass) const;
   ::efl::eolian::return_traits< ::efl::input::Device>::type source_get() const;
   ::efl::eolian::return_traits<void>::type source_set( ::efl::eolian::in_traits< ::efl::input::Device>::type src) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type name_get() const;
   ::efl::eolian::return_traits<void>::type name_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type description_get() const;
   ::efl::eolian::return_traits<void>::type description_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type desc) const;
   ::efl::eolian::return_traits< ::efl::input::Device>::type parent_get() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_INPUT_DEVICE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::input::Device() const;
   operator ::efl::input::Device&();
   operator ::efl::input::Device const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Device,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Device const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace input { 
struct Device : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Device( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Device(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Device(Device const& other) = default;
   Device(Device&& other) = default;
   Device& operator=(Device const& other) = default;
   Device& operator=(Device&& other) = default;
   Device()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Device( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Device(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<Efl_Input_Device_Class>::type device_type_get() const;
   ::efl::eolian::return_traits<void>::type device_type_set( ::efl::eolian::in_traits<Efl_Input_Device_Class>::type klass) const;
   ::efl::eolian::return_traits<Efl_Input_Device_Sub_Class>::type device_subtype_get() const;
   ::efl::eolian::return_traits<void>::type device_subtype_set( ::efl::eolian::in_traits<Efl_Input_Device_Sub_Class>::type klass) const;
   ::efl::eolian::return_traits< ::efl::input::Device>::type source_get() const;
   ::efl::eolian::return_traits<void>::type source_set( ::efl::eolian::in_traits< ::efl::input::Device>::type src) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type name_get() const;
   ::efl::eolian::return_traits<void>::type name_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type description_get() const;
   ::efl::eolian::return_traits<void>::type description_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type desc) const;
   ::efl::eolian::return_traits< ::efl::input::Device>::type parent_get() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_INPUT_DEVICE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Device,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Device const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Device) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Device>::value, "");
} } 
#include "efl_input_device.eo.impl.hh"
#endif
