#ifndef _ELM_INTERFACE_ATSPI_ACCESSIBLE_EO_LEGACY_H_
#define _ELM_INTERFACE_ATSPI_ACCESSIBLE_EO_LEGACY_H_

#ifndef _ELM_INTERFACE_ATSPI_ACCESSIBLE_EO_CLASS_TYPE
#define _ELM_INTERFACE_ATSPI_ACCESSIBLE_EO_CLASS_TYPE

typedef Eo Elm_Interface_Atspi_Accessible;

#endif

#ifndef _ELM_INTERFACE_ATSPI_ACCESSIBLE_EO_TYPES
#define _ELM_INTERFACE_ATSPI_ACCESSIBLE_EO_TYPES

/** Type of accessibility object
 *
 * @ingroup Elm_Atspi
 */
typedef enum
{
  ELM_ATSPI_TYPE_REGULAR = 0, /** default accessibile object */
  ELM_ATSPI_TYPE_DISABLED, /** skip object and its children in accessibility
                            * hierarchy */
  ELM_ATSPI_TYPE_SKIPPED /** skip object in accessibility hierarchy */
} Elm_Atspi_Type;

/** Describes the role of an object visible to AT-SPI Clients.
 *
 * @ingroup Elm_Atspi
 */
typedef enum
{
  ELM_ATSPI_ROLE_INVALID = 0,
  ELM_ATSPI_ROLE_ACCELERATOR_LABEL,
  ELM_ATSPI_ROLE_ALERT,
  ELM_ATSPI_ROLE_ANIMATION,
  ELM_ATSPI_ROLE_ARROW,
  ELM_ATSPI_ROLE_CALENDAR,
  ELM_ATSPI_ROLE_CANVAS,
  ELM_ATSPI_ROLE_CHECK_BOX,
  ELM_ATSPI_ROLE_CHECK_MENU_ITEM,
  ELM_ATSPI_ROLE_COLOR_CHOOSER,
  ELM_ATSPI_ROLE_COLUMN_HEADER,
  ELM_ATSPI_ROLE_COMBO_BOX,
  ELM_ATSPI_ROLE_DATE_EDITOR,
  ELM_ATSPI_ROLE_DESKTOP_ICON,
  ELM_ATSPI_ROLE_DESKTOP_FRAME,
  ELM_ATSPI_ROLE_DIAL,
  ELM_ATSPI_ROLE_DIALOG,
  ELM_ATSPI_ROLE_DIRECTORY_PANE,
  ELM_ATSPI_ROLE_DRAWING_AREA,
  ELM_ATSPI_ROLE_FILE_CHOOSER,
  ELM_ATSPI_ROLE_FILLER,
  ELM_ATSPI_ROLE_FOCUS_TRAVERSABLE,
  ELM_ATSPI_ROLE_FONT_CHOOSER,
  ELM_ATSPI_ROLE_FRAME,
  ELM_ATSPI_ROLE_GLASS_PANE,
  ELM_ATSPI_ROLE_HTML_CONTAINER,
  ELM_ATSPI_ROLE_ICON,
  ELM_ATSPI_ROLE_IMAGE,
  ELM_ATSPI_ROLE_INTERNAL_FRAME,
  ELM_ATSPI_ROLE_LABEL,
  ELM_ATSPI_ROLE_LAYERED_PANE,
  ELM_ATSPI_ROLE_LIST,
  ELM_ATSPI_ROLE_LIST_ITEM,
  ELM_ATSPI_ROLE_MENU,
  ELM_ATSPI_ROLE_MENU_BAR,
  ELM_ATSPI_ROLE_MENU_ITEM,
  ELM_ATSPI_ROLE_OPTION_PANE,
  ELM_ATSPI_ROLE_PAGE_TAB,
  ELM_ATSPI_ROLE_PAGE_TAB_LIST,
  ELM_ATSPI_ROLE_PANEL,
  ELM_ATSPI_ROLE_PASSWORD_TEXT,
  ELM_ATSPI_ROLE_POPUP_MENU,
  ELM_ATSPI_ROLE_PROGRESS_BAR,
  ELM_ATSPI_ROLE_PUSH_BUTTON,
  ELM_ATSPI_ROLE_RADIO_BUTTON,
  ELM_ATSPI_ROLE_RADIO_MENU_ITEM,
  ELM_ATSPI_ROLE_ROOT_PANE,
  ELM_ATSPI_ROLE_ROW_HEADER,
  ELM_ATSPI_ROLE_SCROLL_BAR,
  ELM_ATSPI_ROLE_SCROLL_PANE,
  ELM_ATSPI_ROLE_SEPARATOR,
  ELM_ATSPI_ROLE_SLIDER,
  ELM_ATSPI_ROLE_SPIN_BUTTON,
  ELM_ATSPI_ROLE_SPLIT_PANE,
  ELM_ATSPI_ROLE_STATUS_BAR,
  ELM_ATSPI_ROLE_TABLE,
  ELM_ATSPI_ROLE_TABLE_CELL,
  ELM_ATSPI_ROLE_TABLE_COLUMN_HEADER,
  ELM_ATSPI_ROLE_TABLE_ROW_HEADER,
  ELM_ATSPI_ROLE_TEAROFF_MENU_ITEM,
  ELM_ATSPI_ROLE_TERMINAL,
  ELM_ATSPI_ROLE_TEXT,
  ELM_ATSPI_ROLE_TOGGLE_BUTTON,
  ELM_ATSPI_ROLE_TOOL_BAR,
  ELM_ATSPI_ROLE_TOOL_TIP,
  ELM_ATSPI_ROLE_TREE,
  ELM_ATSPI_ROLE_TREE_TABLE,
  ELM_ATSPI_ROLE_UNKNOWN,
  ELM_ATSPI_ROLE_VIEWPORT,
  ELM_ATSPI_ROLE_WINDOW,
  ELM_ATSPI_ROLE_EXTENDED,
  ELM_ATSPI_ROLE_HEADER,
  ELM_ATSPI_ROLE_FOOTER,
  ELM_ATSPI_ROLE_PARAGRAPH,
  ELM_ATSPI_ROLE_RULER,
  ELM_ATSPI_ROLE_APPLICATION,
  ELM_ATSPI_ROLE_AUTOCOMPLETE,
  ELM_ATSPI_ROLE_EDITBAR,
  ELM_ATSPI_ROLE_EMBEDDED,
  ELM_ATSPI_ROLE_ENTRY,
  ELM_ATSPI_ROLE_CHART,
  ELM_ATSPI_ROLE_CAPTION,
  ELM_ATSPI_ROLE_DOCUMENT_FRAME,
  ELM_ATSPI_ROLE_HEADING,
  ELM_ATSPI_ROLE_PAGE,
  ELM_ATSPI_ROLE_SECTION,
  ELM_ATSPI_ROLE_REDUNDANT_OBJECT,
  ELM_ATSPI_ROLE_FORM,
  ELM_ATSPI_ROLE_LINK,
  ELM_ATSPI_ROLE_INPUT_METHOD_WINDOW,
  ELM_ATSPI_ROLE_TABLE_ROW,
  ELM_ATSPI_ROLE_TREE_ITEM,
  ELM_ATSPI_ROLE_DOCUMENT_SPREADSHEET,
  ELM_ATSPI_ROLE_DOCUMENT_PRESENTATION,
  ELM_ATSPI_ROLE_DOCUMENT_TEXT,
  ELM_ATSPI_ROLE_DOCUMENT_WEB,
  ELM_ATSPI_ROLE_DOCUMENT_EMAIL,
  ELM_ATSPI_ROLE_COMMENT,
  ELM_ATSPI_ROLE_LIST_BOX,
  ELM_ATSPI_ROLE_GROUPING,
  ELM_ATSPI_ROLE_IMAGE_MAP,
  ELM_ATSPI_ROLE_NOTIFICATION,
  ELM_ATSPI_ROLE_INFO_BAR,
  ELM_ATSPI_ROLE_LAST_DEFINED
} Elm_Atspi_Role;

/** Describes a possible states of an object visible to AT-SPI clients.
 *
 * @ingroup Elm_Atspi
 */
typedef enum
{
  ELM_ATSPI_STATE_INVALID = 0,
  ELM_ATSPI_STATE_ACTIVE,
  ELM_ATSPI_STATE_ARMED,
  ELM_ATSPI_STATE_BUSY,
  ELM_ATSPI_STATE_CHECKED,
  ELM_ATSPI_STATE_COLLAPSED,
  ELM_ATSPI_STATE_DEFUNCT,
  ELM_ATSPI_STATE_EDITABLE,
  ELM_ATSPI_STATE_ENABLED,
  ELM_ATSPI_STATE_EXPANDABLE,
  ELM_ATSPI_STATE_EXPANDED,
  ELM_ATSPI_STATE_FOCUSABLE,
  ELM_ATSPI_STATE_FOCUSED,
  ELM_ATSPI_STATE_HAS_TOOLTIP,
  ELM_ATSPI_STATE_HORIZONTAL,
  ELM_ATSPI_STATE_ICONIFIED,
  ELM_ATSPI_STATE_MODAL,
  ELM_ATSPI_STATE_MULTI_LINE,
  ELM_ATSPI_STATE_MULTISELECTABLE,
  ELM_ATSPI_STATE_OPAQUE,
  ELM_ATSPI_STATE_PRESSED,
  ELM_ATSPI_STATE_RESIZABLE,
  ELM_ATSPI_STATE_SELECTABLE,
  ELM_ATSPI_STATE_SELECTED,
  ELM_ATSPI_STATE_SENSITIVE,
  ELM_ATSPI_STATE_SHOWING,
  ELM_ATSPI_STATE_SINGLE_LINE,
  ELM_ATSPI_STATE_STALE,
  ELM_ATSPI_STATE_TRANSIENT,
  ELM_ATSPI_STATE_VERTICAL,
  ELM_ATSPI_STATE_VISIBLE,
  ELM_ATSPI_STATE_MANAGES_DESCENDANTS,
  ELM_ATSPI_STATE_INDETERMINATE,
  ELM_ATSPI_STATE_REQUIRED,
  ELM_ATSPI_STATE_TRUNCATED,
  ELM_ATSPI_STATE_ANIMATED,
  ELM_ATSPI_STATE_INVALID_ENTRY,
  ELM_ATSPI_STATE_SUPPORTS_AUTOCOMPLETION,
  ELM_ATSPI_STATE_SELECTABLE_TEXT,
  ELM_ATSPI_STATE_IS_DEFAULT,
  ELM_ATSPI_STATE_VISITED,
  ELM_ATSPI_STATE_LAST_DEFINED
} Elm_Atspi_State_Type;

/** Describes relation between two objects.
 *
 * @ingroup Elm_Atspi
 */
typedef enum
{
  ELM_ATSPI_RELATION_NULL = 0,
  ELM_ATSPI_RELATION_LABEL_FOR,
  ELM_ATSPI_RELATION_LABELLED_BY,
  ELM_ATSPI_RELATION_CONTROLLER_FOR,
  ELM_ATSPI_RELATION_CONTROLLED_BY,
  ELM_ATSPI_RELATION_MEMBER_OF,
  ELM_ATSPI_RELATION_TOOLTIP_FOR,
  ELM_ATSPI_RELATION_NODE_CHILD_OF,
  ELM_ATSPI_RELATION_NODE_PARENT_OF,
  ELM_ATSPI_RELATION_EXTENDED,
  ELM_ATSPI_RELATION_FLOWS_TO,
  ELM_ATSPI_RELATION_FLOWS_FROM,
  ELM_ATSPI_RELATION_SUBWINDOW_OF,
  ELM_ATSPI_RELATION_EMBEDS,
  ELM_ATSPI_RELATION_EMBEDDED_BY,
  ELM_ATSPI_RELATION_POPUP_FOR,
  ELM_ATSPI_RELATION_PARENT_WINDOW_OF,
  ELM_ATSPI_RELATION_DESCRIPTION_FOR,
  ELM_ATSPI_RELATION_DESCRIBED_BY,
  ELM_ATSPI_RELATION_LAST_DEFINED
} Elm_Atspi_Relation_Type;

/** ATSPI object state set.
 *
 * @ingroup Elm_Atspi
 */
typedef uint64_t Elm_Atspi_State_Set;

/** ATSPI event listener
 *
 * @ingroup Elm_Atspi_Event
 */
typedef struct _Elm_Atspi_Event_Handler Elm_Atspi_Event_Handler;

typedef struct _Elm_Atspi_Event_State_Changed_Data
{
  Elm_Atspi_State_Type type;
  Eina_Bool new_value;
} Elm_Atspi_Event_State_Changed_Data;

typedef struct _Elm_Atspi_Event_Geometry_Changed_Data
{
  int x;
  int y;
  int width;
  int height;
} Elm_Atspi_Event_Geometry_Changed_Data;

typedef struct _Elm_Atspi_Event_Children_Changed_Data
{
  Eina_Bool is_added;
  Eo_Base *child;
} Elm_Atspi_Event_Children_Changed_Data;

typedef struct _Elm_Atspi_Attribute
{
  const char *key;
  const char *value;
} Elm_Atspi_Attribute;

typedef struct _Elm_Atspi_Relation
{
  Elm_Atspi_Relation_Type type;
  Eina_List *objects;
} Elm_Atspi_Relation;

typedef Eina_List *Elm_Atspi_Relation_Set;


#endif
/** ATSPI accessible mixin
 *
 * @ingroup Elm_Interface_Atspi_Accessible
 */

#endif
