#ifndef _ELM_INTERFACE_ATSPI_TEXT_EO_LEGACY_H_
#define _ELM_INTERFACE_ATSPI_TEXT_EO_LEGACY_H_

#ifndef _ELM_INTERFACE_ATSPI_TEXT_EO_CLASS_TYPE
#define _ELM_INTERFACE_ATSPI_TEXT_EO_CLASS_TYPE

typedef Eo Elm_Interface_Atspi_Text;

#endif

#ifndef _ELM_INTERFACE_ATSPI_TEXT_EO_TYPES
#define _ELM_INTERFACE_ATSPI_TEXT_EO_TYPES

typedef enum
{
  ELM_ATSPI_TEXT_GRANULARITY_CHAR = 0,
  ELM_ATSPI_TEXT_GRANULARITY_WORD,
  ELM_ATSPI_TEXT_GRANULARITY_SENTENCE,
  ELM_ATSPI_TEXT_GRANULARITY_LINE,
  ELM_ATSPI_TEXT_GRANULARITY_PARAGRAPH
} Elm_Atspi_Text_Granularity;

typedef enum
{
  ELM_ATSPI_TEXT_CLIP_NONE = 0,
  ELM_ATSPI_TEXT_CLIP_MIN,
  ELM_ATSPI_TEXT_CLIP_MAX,
  ELM_ATSPI_TEXT_CLIP_BOTH
} Elm_Atspi_Text_Clip_Type;

typedef struct _Elm_Atspi_Text_Attribute
{
  const char *name;
  const char *value;
} Elm_Atspi_Text_Attribute;

typedef struct _Elm_Atspi_Text_Range
{
  int start_offset;
  int end_offset;
  char *content;
} Elm_Atspi_Text_Range;

typedef struct _Elm_Atspi_Text_Change_Info
{
  const char *content;
  Eina_Bool inserted;
  size_t pos;
  size_t len;
} Elm_Atspi_Text_Change_Info;


#endif

#endif
