#ifndef EFL_CXX_ELEMENTARY_HH
#define EFL_CXX_ELEMENTARY_HH

#if defined(ELEMENTARY_H) || defined(ELM_WIDGET_H)
#error Do not include Elm C API headers before including Elementary.hh
#endif

#ifndef EFL_BETA_API_SUPPORT
#define EFL_BETA_API_SUPPORT
#endif

#ifndef EFL_EO_API_SUPPORT
#define EFL_EO_API_SUPPORT
#endif

#ifndef ELM_INTERNAL_API_ARGESFSDFEFC
#define ELM_INTERNAL_API_ARGESFSDFEFC
#endif

extern "C" {
#include "Elementary.h"
#include "elm_widget.h"
}

#include <elm_access.eo.hh>
#include <elm_actionslider.eo.hh>
#include <elm_atspi_bridge.eo.hh>
#include <elm_app_client.eo.hh>
#include <elm_app_client_view.eo.hh>
#include <elm_app_server.eo.hh>
#include <elm_app_server_view.eo.hh>
#include <elm_atspi_app_object.eo.hh>
#include <elm_bg.eo.hh>
#include <elm_bubble.eo.hh>
#include <elm_button.eo.hh>
#include <elm_calendar.eo.hh>
#include <elm_check.eo.hh>
#include <elm_clock.eo.hh>
#include <elm_colorselector.eo.hh>
#include <elm_combobox.eo.hh>
#include <elm_conformant.eo.hh>
#include <elm_ctxpopup.eo.hh>
#include <elm_datetime.eo.hh>
#include <elm_dayselector.eo.hh>
#include <elm_diskselector.eo.hh>
#include <elm_entry.eo.hh>
#include <elm_fileselector.eo.hh>
#include <elm_fileselector_button.eo.hh>
#include <elm_fileselector_entry.eo.hh>
#include <efl_ui_flip.eo.hh>
#include <efl_ui_flip_internal_part.eo.hh>
#include <elm_flipselector.eo.hh>
#include <efl_ui_frame.eo.hh>
#include <elm_gengrid.eo.hh>
#include <elm_gengrid_pan.eo.hh>
#include <elm_genlist.eo.hh>
#include <elm_genlist_pan.eo.hh>
#include <elm_gesture_layer.eo.hh>
#include <elm_glview.eo.hh>
#include <elm_hover.eo.hh>
#include <elm_hoversel.eo.hh>
#include <elm_icon.eo.hh>
#include <efl_ui_image.eo.hh>
#include <elm_index.eo.hh>
#include <elm_interface_atspi_accessible.eo.hh>
#include <elm_interface_atspi_action.eo.hh>
#include <elm_interface_atspi_component.eo.hh>
#include <elm_interface_atspi_text_editable.eo.hh>
#include <elm_interface_atspi_image.eo.hh>
#include <elm_interface_atspi_selection.eo.hh>
#include <elm_interface_atspi_text.eo.hh>
#include <elm_interface_atspi_value.eo.hh>
#include <elm_interface_atspi_widget_action.eo.hh>
#include <elm_interface_atspi_window.eo.hh>
#include <elm_interface_fileselector.eo.hh>
#include <elm_interface_scrollable.eo.hh>
#include <elm_inwin.eo.hh>
#include <elm_label.eo.hh>
#include <elm_layout.eo.hh>
#include <elm_list.eo.hh>
#include <elm_map.eo.hh>
#include <elm_map_pan.eo.hh>
#include <elm_menu.eo.hh>
#include <elm_multibuttonentry.eo.hh>
#include <elm_naviframe.eo.hh>
#include <elm_notify.eo.hh>
#include <efl_ui_nstate.eo.hh>
#include <elm_pan.eo.hh>
#include <elm_panel.eo.hh>
#include <elm_panes.eo.hh>
#include <elm_photo.eo.hh>
#include <elm_photocam.eo.hh>
#include <elm_photocam_pan.eo.hh>
#include <elm_player.eo.hh>
#include <elm_plug.eo.hh>
#include <elm_popup.eo.hh>
#include <elm_prefs.eo.hh>
#include <elm_progressbar.eo.hh>
#include <elm_radio.eo.hh>
#include <elm_route.eo.hh>
#include <elm_scroller.eo.hh>
#include <elm_segment_control.eo.hh>
#include <elm_separator.eo.hh>
#include <elm_slider.eo.hh>
#include <elm_slideshow.eo.hh>
#include <elm_spinner.eo.hh>
#include <elm_sys_notify_interface.eo.hh>
#include <elm_sys_notify.eo.hh>
#include <elm_sys_notify_dbus.eo.hh>
#include <elm_systray.eo.hh>
#include <elm_thumb.eo.hh>
#include <elm_toolbar.eo.hh>
#include <efl_ui_video.eo.hh>
#include <elm_view_list.eo.hh>
#include <elm_view_form.eo.hh>
#include <elm_web.eo.hh>
#include <elm_widget.eo.hh>
#include <efl_ui_win.eo.hh>
#include <efl_ui_win_standard.eo.hh>
#include <elm_widget_item.eo.hh>
#include <elm_color_item.eo.hh>
#include <elm_dayselector_item.eo.hh>
#include <elm_hoversel_item.eo.hh>
#include <elm_segment_control_item.eo.hh>
#include <elm_slideshow_item.eo.hh>
#include <elm_flipselector_item.eo.hh>
#include <elm_menu_item.eo.hh>
#include <elm_ctxpopup_item.eo.hh>
#include <elm_index_item.eo.hh>
#include <elm_multibuttonentry_item.eo.hh>
#include <elm_naviframe_item.eo.hh>
#include <elm_genlist_item.eo.hh>
#include <elm_gengrid_item.eo.hh>
#include <elm_list_item.eo.hh>
#include <elm_toolbar_item.eo.hh>
#include <elm_diskselector_item.eo.hh>
#include <elm_popup_item.eo.hh>
#include <efl_ui_box.eo.hh>
#include <efl_ui_box_flow.eo.hh>
#include <efl_ui_grid.eo.hh>
#include <efl_ui_grid_static.eo.hh>
#include <efl_ui_layout_internal_box.eo.hh>
#include <efl_ui_layout_internal_table.eo.hh>
#include <elm_button_internal_part.eo.hh>
#include <elm_ctxpopup_internal_part.eo.hh>
#include <elm_dayselector_internal_part.eo.hh>
#include <elm_entry_internal_part.eo.hh>
#include <elm_fileselector_entry_internal_part.eo.hh>
#include <elm_flip_internal_part.eo.hh>
#include <elm_hover_internal_part.eo.hh>
#include <elm_layout_internal_part.eo.hh>
#include <elm_mapbuf_internal_part.eo.hh>
#include <elm_naviframe_internal_part.eo.hh>
#include <elm_notify_internal_part.eo.hh>
#include <elm_panel_internal_part.eo.hh>
#include <elm_player_internal_part.eo.hh>
#include <elm_progressbar_internal_part.eo.hh>
#include <elm_popup_internal_part.eo.hh>
#include <elm_scroller_internal_part.eo.hh>
#include <elm_code_widget.eo.hh>
#include <efl_ui_text_interactive.eo.hh>
#include <efl_ui_text.eo.hh>
#include <efl_ui_text_editable.eo.hh>
#include <efl_config_global.eo.hh>
#endif

