#ifndef ELM_APP_CLIENT_EO_HH
#define ELM_APP_CLIENT_EO_HH
#include <Eo.h>

extern "C" {
#include "elm_app_client.eo.h"
#include "elm_app_client_view.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "elm_app_client_view.eo.hh"
#include "eo_base.eo.hh"
namespace elm { namespace app { 
struct Client;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::app::Client> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace app { 
struct Client {
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::elm::app::client::View>>::type views_get() const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type package_get() const;
   ::efl::eolian::return_traits<void>::type constructor( ::efl::eolian::in_traits< ::efl::eina::string_view>::type package) const;
   ::efl::eolian::return_traits<void>::type view_all_close() const;
   ::efl::eolian::return_traits<void>::type terminate() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_APP_CLIENT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::app::Client() const;
   operator ::elm::app::Client&();
   operator ::elm::app::Client const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Client,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Client const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace elm { namespace app { 
struct Client : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Client( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Client(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Client(Client const& other) = default;
   Client(Client&& other) = default;
   Client& operator=(Client const& other) = default;
   Client& operator=(Client&& other) = default;
   Client()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Client( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Client(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::elm::app::client::View>>::type views_get() const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type package_get() const;
   ::efl::eolian::return_traits<void>::type constructor( ::efl::eolian::in_traits< ::efl::eina::string_view>::type package) const;
   ::efl::eolian::return_traits<void>::type view_all_close() const;
   ::efl::eolian::return_traits<void>::type terminate() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_APP_CLIENT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct view_created_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_EVENT_VIEW_CREATED; }
      typedef void parameter_type;
   } const view_created_event;
   static struct view_deleted_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_EVENT_VIEW_DELETED; }
      typedef void parameter_type;
   } const view_deleted_event;
   static struct view_list_loaded_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED; }
      typedef void parameter_type;
   } const view_list_loaded_event;
   static struct application_terminated_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED; }
      typedef void parameter_type;
   } const application_terminated_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Client,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Client const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Client) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Client>::value, "");
} } 
#include "elm_app_client.eo.impl.hh"
#endif
