#ifndef ELM_APP_CLIENT_VIEW_EO_HH
#define ELM_APP_CLIENT_VIEW_EO_HH
#include <Eo.h>

extern "C" {
#include "elm_app_client_view.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "eo_base.eo.hh"
namespace elm { namespace app { namespace client { 
struct View;
} } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::app::client::View> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace app { namespace client { 
struct View {
   ::efl::eolian::return_traits<Elm_App_View_State>::type state_get() const;
   ::efl::eolian::return_traits<int>::type new_events_get() const;
   ::efl::eolian::return_traits<int>::type window_get() const;
   ::efl::eolian::return_traits< ::efl::eina::stringshare>::type path_get() const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type package_get() const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type icon_get() const;
   ::efl::eolian::return_traits< unsigned short>::type progress_get() const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type title_get() const;
   ::efl::eolian::return_traits<void>::type path_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   ::efl::eolian::return_traits<void>::type pause( ::efl::eolian::in_traits< ::efl::eina::optional<Elm_App_Client_View_Cb>>::type cb,  ::efl::eolian::in_traits<void const*>::type data) const;
   ::efl::eolian::return_traits<void>::type resume( ::efl::eolian::in_traits< ::efl::eina::optional<Elm_App_Client_View_Cb>>::type cb,  ::efl::eolian::in_traits<void const*>::type data) const;
   ::efl::eolian::return_traits<void>::type close( ::efl::eolian::in_traits< ::efl::eina::optional<Elm_App_Client_View_Cb>>::type cb,  ::efl::eolian::in_traits<void const*>::type data) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_APP_CLIENT_VIEW_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::app::client::View() const;
   operator ::elm::app::client::View&();
   operator ::elm::app::client::View const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<View,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<View const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } } 
}
namespace elm { namespace app { namespace client { 
struct View : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit View( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit View(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   View(View const& other) = default;
   View(View&& other) = default;
   View& operator=(View const& other) = default;
   View& operator=(View&& other) = default;
   View()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   View( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> View(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<Elm_App_View_State>::type state_get() const;
   ::efl::eolian::return_traits<int>::type new_events_get() const;
   ::efl::eolian::return_traits<int>::type window_get() const;
   ::efl::eolian::return_traits< ::efl::eina::stringshare>::type path_get() const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type package_get() const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type icon_get() const;
   ::efl::eolian::return_traits< unsigned short>::type progress_get() const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type title_get() const;
   ::efl::eolian::return_traits<void>::type path_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   ::efl::eolian::return_traits<void>::type pause( ::efl::eolian::in_traits< ::efl::eina::optional<Elm_App_Client_View_Cb>>::type cb,  ::efl::eolian::in_traits<void const*>::type data) const;
   ::efl::eolian::return_traits<void>::type resume( ::efl::eolian::in_traits< ::efl::eina::optional<Elm_App_Client_View_Cb>>::type cb,  ::efl::eolian::in_traits<void const*>::type data) const;
   ::efl::eolian::return_traits<void>::type close( ::efl::eolian::in_traits< ::efl::eina::optional<Elm_App_Client_View_Cb>>::type cb,  ::efl::eolian::in_traits<void const*>::type data) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_APP_CLIENT_VIEW_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct state_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_VIEW_EVENT_STATE_CHANGED; }
      typedef void parameter_type;
   } const state_changed_event;
   static struct title_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_VIEW_EVENT_TITLE_CHANGED; }
      typedef void parameter_type;
   } const title_changed_event;
   static struct icon_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_VIEW_EVENT_ICON_CHANGED; }
      typedef void parameter_type;
   } const icon_changed_event;
   static struct icon_pixels_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_VIEW_EVENT_ICON_PIXELS_CHANGED; }
      typedef void parameter_type;
   } const icon_pixels_changed_event;
   static struct new_events_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_VIEW_EVENT_NEW_EVENTS_CHANGED; }
      typedef void parameter_type;
   } const new_events_changed_event;
   static struct progress_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_VIEW_EVENT_PROGRESS_CHANGED; }
      typedef void parameter_type;
   } const progress_changed_event;
   static struct window_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_VIEW_EVENT_WINDOW_CHANGED; }
      typedef void parameter_type;
   } const window_changed_event;
   static struct property_changed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_APP_CLIENT_VIEW_EVENT_PROPERTY_CHANGED; }
      typedef void parameter_type;
   } const property_changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<View,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<View const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(View) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<View>::value, "");
} } } 
#include "elm_app_client_view.eo.impl.hh"
#endif
