#ifndef ELM_GESTURE_LAYER_EO_HH
#define ELM_GESTURE_LAYER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "elm_gesture_layer.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_widget.eo.h"
#include "elm_widget_item.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_group.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "elm_widget.eo.hh"
#include "elm_widget_item.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace elm { 
struct Gesture_Layer;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::Gesture_Layer> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { 
struct Gesture_Layer {
   ::efl::eolian::return_traits<double>::type zoom_step_get() const;
   ::efl::eolian::return_traits<void>::type zoom_step_set( ::efl::eolian::in_traits<double>::type step) const;
   ::efl::eolian::return_traits<Evas_Coord>::type tap_finger_size_get() const;
   ::efl::eolian::return_traits<void>::type tap_finger_size_set( ::efl::eolian::in_traits<Evas_Coord>::type sz) const;
   ::efl::eolian::return_traits<bool>::type hold_events_get() const;
   ::efl::eolian::return_traits<void>::type hold_events_set( ::efl::eolian::in_traits<bool>::type hold_events) const;
   ::efl::eolian::return_traits<double>::type rotate_step_get() const;
   ::efl::eolian::return_traits<void>::type rotate_step_set( ::efl::eolian::in_traits<double>::type step) const;
   ::efl::eolian::return_traits<void>::type cb_set( ::efl::eolian::in_traits<Elm_Gesture_Type>::type idx,  ::efl::eolian::in_traits<Elm_Gesture_State>::type cb_type,  ::efl::eolian::in_traits<Elm_Gesture_Event_Cb>::type cb,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<bool>::type attach( ::efl::eolian::in_traits< ::efl::canvas::Object>::type target) const;
   ::efl::eolian::return_traits<void>::type cb_del( ::efl::eolian::in_traits<Elm_Gesture_Type>::type idx,  ::efl::eolian::in_traits<Elm_Gesture_State>::type cb_type,  ::efl::eolian::in_traits<Elm_Gesture_Event_Cb>::type cb,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<void>::type cb_add( ::efl::eolian::in_traits<Elm_Gesture_Type>::type idx,  ::efl::eolian::in_traits<Elm_Gesture_State>::type cb_type,  ::efl::eolian::in_traits<Elm_Gesture_Event_Cb>::type cb,  ::efl::eolian::in_traits<void*>::type data) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_GESTURE_LAYER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::Gesture_Layer() const;
   operator ::elm::Gesture_Layer&();
   operator ::elm::Gesture_Layer const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Gesture_Layer,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Gesture_Layer const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace elm { 
struct Gesture_Layer : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::canvas::Group)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::elm::Widget)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Gesture_Layer( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Gesture_Layer(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Gesture_Layer(Gesture_Layer const& other) = default;
   Gesture_Layer(Gesture_Layer&& other) = default;
   Gesture_Layer& operator=(Gesture_Layer const& other) = default;
   Gesture_Layer& operator=(Gesture_Layer&& other) = default;
   Gesture_Layer()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Gesture_Layer( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Gesture_Layer(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<double>::type zoom_step_get() const;
   ::efl::eolian::return_traits<void>::type zoom_step_set( ::efl::eolian::in_traits<double>::type step) const;
   ::efl::eolian::return_traits<Evas_Coord>::type tap_finger_size_get() const;
   ::efl::eolian::return_traits<void>::type tap_finger_size_set( ::efl::eolian::in_traits<Evas_Coord>::type sz) const;
   ::efl::eolian::return_traits<bool>::type hold_events_get() const;
   ::efl::eolian::return_traits<void>::type hold_events_set( ::efl::eolian::in_traits<bool>::type hold_events) const;
   ::efl::eolian::return_traits<double>::type rotate_step_get() const;
   ::efl::eolian::return_traits<void>::type rotate_step_set( ::efl::eolian::in_traits<double>::type step) const;
   ::efl::eolian::return_traits<void>::type cb_set( ::efl::eolian::in_traits<Elm_Gesture_Type>::type idx,  ::efl::eolian::in_traits<Elm_Gesture_State>::type cb_type,  ::efl::eolian::in_traits<Elm_Gesture_Event_Cb>::type cb,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<bool>::type attach( ::efl::eolian::in_traits< ::efl::canvas::Object>::type target) const;
   ::efl::eolian::return_traits<void>::type cb_del( ::efl::eolian::in_traits<Elm_Gesture_Type>::type idx,  ::efl::eolian::in_traits<Elm_Gesture_State>::type cb_type,  ::efl::eolian::in_traits<Elm_Gesture_Event_Cb>::type cb,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<void>::type cb_add( ::efl::eolian::in_traits<Elm_Gesture_Type>::type idx,  ::efl::eolian::in_traits<Elm_Gesture_State>::type cb_type,  ::efl::eolian::in_traits<Elm_Gesture_Event_Cb>::type cb,  ::efl::eolian::in_traits<void*>::type data) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_GESTURE_LAYER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Gesture_Layer,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Gesture_Layer const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Gesture_Layer) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Gesture_Layer>::value, "");
} 
#include "elm_gesture_layer.eo.impl.hh"
#endif
