#ifndef ELM_GLVIEW_EO_HH
#define ELM_GLVIEW_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_gfx_view.eo.h"
#include "efl_input_interface.eo.h"
#include "elm_glview.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_widget.eo.h"
#include "elm_widget_item.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_group.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_gfx_view.eo.hh"
#include "efl_input_interface.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "elm_widget.eo.hh"
#include "elm_widget_item.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace elm { 
struct Glview;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::Glview> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { 
struct Glview {
   ::efl::eolian::return_traits<bool>::type resize_policy_set( ::efl::eolian::in_traits<Elm_GLView_Resize_Policy>::type policy) const;
   ::efl::eolian::return_traits<bool>::type render_policy_set( ::efl::eolian::in_traits<Elm_GLView_Render_Policy>::type policy) const;
   ::efl::eolian::return_traits<bool>::type mode_set( ::efl::eolian::in_traits<Elm_GLView_Mode>::type mode) const;
   ::efl::eolian::return_traits<int>::type rotation_get() const;
   ::efl::eolian::return_traits<void>::type version_constructor( ::efl::eolian::in_traits<Evas_GL_Context_Version>::type version) const;
   ::efl::eolian::return_traits<void>::type draw_request() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_GLVIEW_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::Glview() const;
   operator ::elm::Glview&();
   operator ::elm::Glview const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Glview,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::View,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Glview const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::View const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace elm { 
struct Glview : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::canvas::Group)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx::View)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::elm::Widget)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Glview( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Glview(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Glview(Glview const& other) = default;
   Glview(Glview&& other) = default;
   Glview& operator=(Glview const& other) = default;
   Glview& operator=(Glview&& other) = default;
   Glview()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Glview( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Glview(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type resize_policy_set( ::efl::eolian::in_traits<Elm_GLView_Resize_Policy>::type policy) const;
   ::efl::eolian::return_traits<bool>::type render_policy_set( ::efl::eolian::in_traits<Elm_GLView_Render_Policy>::type policy) const;
   ::efl::eolian::return_traits<bool>::type mode_set( ::efl::eolian::in_traits<Elm_GLView_Mode>::type mode) const;
   ::efl::eolian::return_traits<int>::type rotation_get() const;
   ::efl::eolian::return_traits<void>::type version_constructor( ::efl::eolian::in_traits<Evas_GL_Context_Version>::type version) const;
   ::efl::eolian::return_traits<void>::type draw_request() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_GLVIEW_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct created_event
   {
      static Eo_Event_Description const* description()
      { return ELM_GLVIEW_EVENT_CREATED; }
      typedef void parameter_type;
   } const created_event;
   static struct destroyed_event
   {
      static Eo_Event_Description const* description()
      { return ELM_GLVIEW_EVENT_DESTROYED; }
      typedef void parameter_type;
   } const destroyed_event;
   static struct resized_event
   {
      static Eo_Event_Description const* description()
      { return ELM_GLVIEW_EVENT_RESIZED; }
      typedef void parameter_type;
   } const resized_event;
   static struct render_event
   {
      static Eo_Event_Description const* description()
      { return ELM_GLVIEW_EVENT_RENDER; }
      typedef void parameter_type;
   } const render_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Glview,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::View,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Glview const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::View const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Glview) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Glview>::value, "");
} 
#include "elm_glview.eo.impl.hh"
#endif
