#ifndef ELM_INDEX_ITEM_EO_HH
#define ELM_INDEX_ITEM_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_canvas_object.eo.h"
#include "elm_index_item.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_action.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_interface_atspi_widget_action.eo.h"
#include "elm_widget_item.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_canvas_object.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_action.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"
#include "elm_widget_item.eo.hh"
#include "eo_base.eo.hh"
namespace elm { namespace index { 
struct Item;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::index::Item> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace index { 
struct Item {
   ::efl::eolian::return_traits<void>::type selected_set( ::efl::eolian::in_traits<bool>::type selected) const;
   ::efl::eolian::return_traits<void>::type priority_set( ::efl::eolian::in_traits<int>::type priority) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type letter_get() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_INDEX_ITEM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::index::Item() const;
   operator ::elm::index::Item&();
   operator ::elm::index::Item const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Action,  ::elm::interface::Atspi_Component,  ::elm::interface::Atspi_Widget_Action,  ::elm::widget::Item,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Action const ,  ::elm::interface::Atspi_Component const ,  ::elm::interface::Atspi_Widget_Action const ,  ::elm::widget::Item const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace elm { namespace index { 
struct Item : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Action)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Widget_Action)
   , EO_CXX_INHERIT( ::elm ::widget::Item)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Item( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Item(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Item(Item const& other) = default;
   Item(Item&& other) = default;
   Item& operator=(Item const& other) = default;
   Item& operator=(Item&& other) = default;
   Item()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Item( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Item(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type selected_set( ::efl::eolian::in_traits<bool>::type selected) const;
   ::efl::eolian::return_traits<void>::type priority_set( ::efl::eolian::in_traits<int>::type priority) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type letter_get() const;
   static Eo_Class const* _eo_class()
   {
      return ELM_INDEX_ITEM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Action,  ::elm::interface::Atspi_Component,  ::elm::interface::Atspi_Widget_Action,  ::elm::widget::Item,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Action const ,  ::elm::interface::Atspi_Component const ,  ::elm::interface::Atspi_Widget_Action const ,  ::elm::widget::Item const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Item) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Item>::value, "");
} } 
#include "elm_index_item.eo.impl.hh"
#endif
