#ifndef ELM_MAP_EO_HH
#define ELM_MAP_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "efl_ui_clickable.eo.h"
#include "efl_ui_scrollable.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_action.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_interface_atspi_widget_action.eo.h"
#include "elm_interface_scrollable.eo.h"
#include "elm_map.eo.h"
#include "elm_widget.eo.h"
#include "elm_widget_item.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_group.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "efl_ui_clickable.eo.hh"
#include "efl_ui_scrollable.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_action.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"
#include "elm_interface_scrollable.eo.hh"
#include "elm_widget.eo.hh"
#include "elm_widget_item.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace elm { 
struct Map;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::Map> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { 
struct Map {
   ::efl::eolian::return_traits<int>::type zoom_get() const;
   ::efl::eolian::return_traits<void>::type zoom_set( ::efl::eolian::in_traits<int>::type zoom) const;
   ::efl::eolian::return_traits<bool>::type paused_get() const;
   ::efl::eolian::return_traits<void>::type paused_set( ::efl::eolian::in_traits<bool>::type paused) const;
   ::efl::eolian::return_traits<bool>::type wheel_disabled_get() const;
   ::efl::eolian::return_traits<void>::type wheel_disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
   ::efl::eolian::return_traits<int>::type zoom_min_get() const;
   ::efl::eolian::return_traits<void>::type zoom_min_set( ::efl::eolian::in_traits<int>::type zoom) const;
   ::efl::eolian::return_traits<void>::type rotate_get( ::efl::eolian::out_traits<double>::type degree,  ::efl::eolian::out_traits<Evas_Coord>::type cx,  ::efl::eolian::out_traits<Evas_Coord>::type cy) const;
   ::efl::eolian::return_traits<void>::type rotate_set( ::efl::eolian::in_traits<double>::type degree,  ::efl::eolian::in_traits<Evas_Coord>::type cx,  ::efl::eolian::in_traits<Evas_Coord>::type cy) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type user_agent_get() const;
   ::efl::eolian::return_traits<void>::type user_agent_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type user_agent) const;
   ::efl::eolian::return_traits<int>::type zoom_max_get() const;
   ::efl::eolian::return_traits<void>::type zoom_max_set( ::efl::eolian::in_traits<int>::type zoom) const;
   ::efl::eolian::return_traits<Elm_Map_Zoom_Mode>::type zoom_mode_get() const;
   ::efl::eolian::return_traits<void>::type zoom_mode_set( ::efl::eolian::in_traits<Elm_Map_Zoom_Mode>::type mode) const;
   ::efl::eolian::return_traits<void>::type region_get( ::efl::eolian::out_traits<double>::type lon,  ::efl::eolian::out_traits<double>::type lat) const;
   ::efl::eolian::return_traits<void>::type tile_load_status_get( ::efl::eolian::out_traits<int>::type try_num,  ::efl::eolian::out_traits<int>::type finish_num) const;
   ::efl::eolian::return_traits<void>::type source_set( ::efl::eolian::in_traits<Elm_Map_Source_Type>::type type,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source_name) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type source_get( ::efl::eolian::in_traits<Elm_Map_Source_Type>::type type) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type track_add( ::efl::eolian::in_traits<void*>::type emap) const;
   ::efl::eolian::return_traits<void>::type region_to_canvas_convert( ::efl::eolian::in_traits<double>::type lon,  ::efl::eolian::in_traits<double>::type lat,  ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   ::efl::eolian::return_traits<void>::type region_show( ::efl::eolian::in_traits<double>::type lon,  ::efl::eolian::in_traits<double>::type lat) const;
   ::efl::eolian::return_traits<void>::type name_search( ::efl::eolian::in_traits< ::efl::eina::string_view>::type address,  ::efl::eolian::in_traits< ::efl::eina::optional<Elm_Map_Name_List_Cb>>::type name_cb,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<void>::type region_bring_in( ::efl::eolian::in_traits<double>::type lon,  ::efl::eolian::in_traits<double>::type lat) const;
   ::efl::eolian::return_traits<void>::type region_zoom_bring_in( ::efl::eolian::in_traits<int>::type zoom,  ::efl::eolian::in_traits<double>::type lon,  ::efl::eolian::in_traits<double>::type lat) const;
   ::efl::eolian::return_traits<void>::type track_remove( ::efl::eolian::in_traits< ::efl::canvas::Object>::type route) const;
   ::efl::eolian::return_traits<void>::type canvas_to_region_convert( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<double>::type lon,  ::efl::eolian::out_traits<double>::type lat) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_MAP_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::Map() const;
   operator ::elm::Map&();
   operator ::elm::Map const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Map,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::ui::Clickable,  ::efl::ui::Scrollable,  ::elm::Interface_Scrollable,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Action,  ::elm::interface::Atspi_Component,  ::elm::interface::Atspi_Widget_Action,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Map const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::ui::Clickable const ,  ::efl::ui::Scrollable const ,  ::elm::Interface_Scrollable const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Action const ,  ::elm::interface::Atspi_Component const ,  ::elm::interface::Atspi_Widget_Action const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace elm { 
struct Map : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::canvas::Group)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::efl ::ui::Clickable)
   , EO_CXX_INHERIT( ::efl ::ui::Scrollable)
   , EO_CXX_INHERIT( ::elm::Interface_Scrollable)
   , EO_CXX_INHERIT( ::elm::Widget)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Action)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Widget_Action)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Map( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Map(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Map(Map const& other) = default;
   Map(Map&& other) = default;
   Map& operator=(Map const& other) = default;
   Map& operator=(Map&& other) = default;
   Map()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Map( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Map(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<int>::type zoom_get() const;
   ::efl::eolian::return_traits<void>::type zoom_set( ::efl::eolian::in_traits<int>::type zoom) const;
   ::efl::eolian::return_traits<bool>::type paused_get() const;
   ::efl::eolian::return_traits<void>::type paused_set( ::efl::eolian::in_traits<bool>::type paused) const;
   ::efl::eolian::return_traits<bool>::type wheel_disabled_get() const;
   ::efl::eolian::return_traits<void>::type wheel_disabled_set( ::efl::eolian::in_traits<bool>::type disabled) const;
   ::efl::eolian::return_traits<int>::type zoom_min_get() const;
   ::efl::eolian::return_traits<void>::type zoom_min_set( ::efl::eolian::in_traits<int>::type zoom) const;
   ::efl::eolian::return_traits<void>::type rotate_get( ::efl::eolian::out_traits<double>::type degree,  ::efl::eolian::out_traits<Evas_Coord>::type cx,  ::efl::eolian::out_traits<Evas_Coord>::type cy) const;
   ::efl::eolian::return_traits<void>::type rotate_set( ::efl::eolian::in_traits<double>::type degree,  ::efl::eolian::in_traits<Evas_Coord>::type cx,  ::efl::eolian::in_traits<Evas_Coord>::type cy) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type user_agent_get() const;
   ::efl::eolian::return_traits<void>::type user_agent_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type user_agent) const;
   ::efl::eolian::return_traits<int>::type zoom_max_get() const;
   ::efl::eolian::return_traits<void>::type zoom_max_set( ::efl::eolian::in_traits<int>::type zoom) const;
   ::efl::eolian::return_traits<Elm_Map_Zoom_Mode>::type zoom_mode_get() const;
   ::efl::eolian::return_traits<void>::type zoom_mode_set( ::efl::eolian::in_traits<Elm_Map_Zoom_Mode>::type mode) const;
   ::efl::eolian::return_traits<void>::type region_get( ::efl::eolian::out_traits<double>::type lon,  ::efl::eolian::out_traits<double>::type lat) const;
   ::efl::eolian::return_traits<void>::type tile_load_status_get( ::efl::eolian::out_traits<int>::type try_num,  ::efl::eolian::out_traits<int>::type finish_num) const;
   ::efl::eolian::return_traits<void>::type source_set( ::efl::eolian::in_traits<Elm_Map_Source_Type>::type type,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source_name) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type source_get( ::efl::eolian::in_traits<Elm_Map_Source_Type>::type type) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type track_add( ::efl::eolian::in_traits<void*>::type emap) const;
   ::efl::eolian::return_traits<void>::type region_to_canvas_convert( ::efl::eolian::in_traits<double>::type lon,  ::efl::eolian::in_traits<double>::type lat,  ::efl::eolian::out_traits<Evas_Coord>::type x,  ::efl::eolian::out_traits<Evas_Coord>::type y) const;
   ::efl::eolian::return_traits<void>::type region_show( ::efl::eolian::in_traits<double>::type lon,  ::efl::eolian::in_traits<double>::type lat) const;
   ::efl::eolian::return_traits<void>::type name_search( ::efl::eolian::in_traits< ::efl::eina::string_view>::type address,  ::efl::eolian::in_traits< ::efl::eina::optional<Elm_Map_Name_List_Cb>>::type name_cb,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<void>::type region_bring_in( ::efl::eolian::in_traits<double>::type lon,  ::efl::eolian::in_traits<double>::type lat) const;
   ::efl::eolian::return_traits<void>::type region_zoom_bring_in( ::efl::eolian::in_traits<int>::type zoom,  ::efl::eolian::in_traits<double>::type lon,  ::efl::eolian::in_traits<double>::type lat) const;
   ::efl::eolian::return_traits<void>::type track_remove( ::efl::eolian::in_traits< ::efl::canvas::Object>::type route) const;
   ::efl::eolian::return_traits<void>::type canvas_to_region_convert( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y,  ::efl::eolian::out_traits<double>::type lon,  ::efl::eolian::out_traits<double>::type lat) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_MAP_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct press_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_PRESS; }
      typedef void parameter_type;
   } const press_event;
   static struct zoom_change_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_ZOOM_CHANGE; }
      typedef void parameter_type;
   } const zoom_change_event;
   static struct loaded_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_LOADED; }
      typedef void parameter_type;
   } const loaded_event;
   static struct tile_load_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_TILE_LOAD; }
      typedef void parameter_type;
   } const tile_load_event;
   static struct tile_loaded_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_TILE_LOADED; }
      typedef void parameter_type;
   } const tile_loaded_event;
   static struct tile_loaded_fail_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_TILE_LOADED_FAIL; }
      typedef void parameter_type;
   } const tile_loaded_fail_event;
   static struct route_load_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_ROUTE_LOAD; }
      typedef void parameter_type;
   } const route_load_event;
   static struct route_loaded_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_ROUTE_LOADED; }
      typedef void parameter_type;
   } const route_loaded_event;
   static struct route_loaded_fail_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_ROUTE_LOADED_FAIL; }
      typedef void parameter_type;
   } const route_loaded_fail_event;
   static struct name_load_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_NAME_LOAD; }
      typedef void parameter_type;
   } const name_load_event;
   static struct name_loaded_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_NAME_LOADED; }
      typedef void parameter_type;
   } const name_loaded_event;
   static struct name_loaded_fail_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_NAME_LOADED_FAIL; }
      typedef void parameter_type;
   } const name_loaded_fail_event;
   static struct overlay_clicked_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_OVERLAY_CLICKED; }
      typedef void parameter_type;
   } const overlay_clicked_event;
   static struct overlay_del_event
   {
      static Eo_Event_Description const* description()
      { return ELM_MAP_EVENT_OVERLAY_DEL; }
      typedef void parameter_type;
   } const overlay_del_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Map,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::ui::Clickable,  ::efl::ui::Scrollable,  ::elm::Interface_Scrollable,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Action,  ::elm::interface::Atspi_Component,  ::elm::interface::Atspi_Widget_Action,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Map const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::ui::Clickable const ,  ::efl::ui::Scrollable const ,  ::elm::Interface_Scrollable const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Action const ,  ::elm::interface::Atspi_Component const ,  ::elm::interface::Atspi_Widget_Action const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Map) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Map>::value, "");
} 
#include "elm_map.eo.impl.hh"
#endif
