#ifndef ELM_PHOTOCAM_EO_HH
#define ELM_PHOTOCAM_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_file.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "efl_ui_clickable.eo.h"
#include "efl_ui_scrollable.eo.h"
#include "efl_ui_zoomable.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_action.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_interface_atspi_widget_action.eo.h"
#include "elm_interface_scrollable.eo.h"
#include "elm_photocam.eo.h"
#include "elm_widget.eo.h"
#include "elm_widget_item.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_group.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_file.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "efl_ui_clickable.eo.hh"
#include "efl_ui_scrollable.eo.hh"
#include "efl_ui_zoomable.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_action.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"
#include "elm_interface_scrollable.eo.hh"
#include "elm_widget.eo.hh"
#include "elm_widget_item.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace elm { 
struct Photocam;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::Photocam> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { 
struct Photocam {
   ::efl::eolian::return_traits<bool>::type paused_get() const;
   ::efl::eolian::return_traits<void>::type paused_set( ::efl::eolian::in_traits<bool>::type paused) const;
   ::efl::eolian::return_traits<bool>::type gesture_enabled_get() const;
   ::efl::eolian::return_traits<void>::type gesture_enabled_set( ::efl::eolian::in_traits<bool>::type gesture) const;
   ::efl::eolian::return_traits<double>::type zoom_get() const;
   ::efl::eolian::return_traits<void>::type zoom_set( ::efl::eolian::in_traits<double>::type zoom) const;
   ::efl::eolian::return_traits<Elm_Photocam_Zoom_Mode>::type zoom_mode_get() const;
   ::efl::eolian::return_traits<void>::type zoom_mode_set( ::efl::eolian::in_traits<Elm_Photocam_Zoom_Mode>::type mode) const;
   ::efl::eolian::return_traits<void>::type image_region_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type internal_image_get() const;
   ::efl::eolian::return_traits<void>::type image_size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<Evas_Image_Orient>::type image_orient_get() const;
   ::efl::eolian::return_traits<void>::type image_orient_set( ::efl::eolian::in_traits<Evas_Image_Orient>::type orient) const;
   ::efl::eolian::return_traits<void>::type image_region_show( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_PHOTOCAM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::Photocam() const;
   operator ::elm::Photocam&();
   operator ::elm::Photocam const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Photocam,  ::efl::Animator,  ::efl::File,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::ui::Clickable,  ::efl::ui::Scrollable,  ::efl::ui::Zoomable,  ::elm::Interface_Scrollable,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Action,  ::elm::interface::Atspi_Component,  ::elm::interface::Atspi_Widget_Action,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Photocam const ,  ::efl::Animator const ,  ::efl::File const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::ui::Clickable const ,  ::efl::ui::Scrollable const ,  ::efl::ui::Zoomable const ,  ::elm::Interface_Scrollable const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Action const ,  ::elm::interface::Atspi_Component const ,  ::elm::interface::Atspi_Widget_Action const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace elm { 
struct Photocam : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::File)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::canvas::Group)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::efl ::ui::Clickable)
   , EO_CXX_INHERIT( ::efl ::ui::Scrollable)
   , EO_CXX_INHERIT( ::efl ::ui::Zoomable)
   , EO_CXX_INHERIT( ::elm::Interface_Scrollable)
   , EO_CXX_INHERIT( ::elm::Widget)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Action)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Widget_Action)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Photocam( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Photocam(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Photocam(Photocam const& other) = default;
   Photocam(Photocam&& other) = default;
   Photocam& operator=(Photocam const& other) = default;
   Photocam& operator=(Photocam&& other) = default;
   Photocam()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Photocam( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Photocam(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type paused_get() const;
   ::efl::eolian::return_traits<void>::type paused_set( ::efl::eolian::in_traits<bool>::type paused) const;
   ::efl::eolian::return_traits<bool>::type gesture_enabled_get() const;
   ::efl::eolian::return_traits<void>::type gesture_enabled_set( ::efl::eolian::in_traits<bool>::type gesture) const;
   ::efl::eolian::return_traits<double>::type zoom_get() const;
   ::efl::eolian::return_traits<void>::type zoom_set( ::efl::eolian::in_traits<double>::type zoom) const;
   ::efl::eolian::return_traits<Elm_Photocam_Zoom_Mode>::type zoom_mode_get() const;
   ::efl::eolian::return_traits<void>::type zoom_mode_set( ::efl::eolian::in_traits<Elm_Photocam_Zoom_Mode>::type mode) const;
   ::efl::eolian::return_traits<void>::type image_region_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type internal_image_get() const;
   ::efl::eolian::return_traits<void>::type image_size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<Evas_Image_Orient>::type image_orient_get() const;
   ::efl::eolian::return_traits<void>::type image_orient_set( ::efl::eolian::in_traits<Evas_Image_Orient>::type orient) const;
   ::efl::eolian::return_traits<void>::type image_region_show( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_PHOTOCAM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct press_event
   {
      static Eo_Event_Description const* description()
      { return ELM_PHOTOCAM_EVENT_PRESS; }
      typedef void parameter_type;
   } const press_event;
   static struct load_event
   {
      static Eo_Event_Description const* description()
      { return ELM_PHOTOCAM_EVENT_LOAD; }
      typedef void parameter_type;
   } const load_event;
   static struct loaded_event
   {
      static Eo_Event_Description const* description()
      { return ELM_PHOTOCAM_EVENT_LOADED; }
      typedef void parameter_type;
   } const loaded_event;
   static struct load_detail_event
   {
      static Eo_Event_Description const* description()
      { return ELM_PHOTOCAM_EVENT_LOAD_DETAIL; }
      typedef void parameter_type;
   } const load_detail_event;
   static struct loaded_detail_event
   {
      static Eo_Event_Description const* description()
      { return ELM_PHOTOCAM_EVENT_LOADED_DETAIL; }
      typedef void parameter_type;
   } const loaded_detail_event;
   static struct download_start_event
   {
      static Eo_Event_Description const* description()
      { return ELM_PHOTOCAM_EVENT_DOWNLOAD_START; }
      typedef void parameter_type;
   } const download_start_event;
   static struct download_progress_event
   {
      static Eo_Event_Description const* description()
      { return ELM_PHOTOCAM_EVENT_DOWNLOAD_PROGRESS; }
      typedef void parameter_type;
   } const download_progress_event;
   static struct download_done_event
   {
      static Eo_Event_Description const* description()
      { return ELM_PHOTOCAM_EVENT_DOWNLOAD_DONE; }
      typedef void parameter_type;
   } const download_done_event;
   static struct download_error_event
   {
      static Eo_Event_Description const* description()
      { return ELM_PHOTOCAM_EVENT_DOWNLOAD_ERROR; }
      typedef void parameter_type;
   } const download_error_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Photocam,  ::efl::Animator,  ::efl::File,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::ui::Clickable,  ::efl::ui::Scrollable,  ::efl::ui::Zoomable,  ::elm::Interface_Scrollable,  ::elm::Widget,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Action,  ::elm::interface::Atspi_Component,  ::elm::interface::Atspi_Widget_Action,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Photocam const ,  ::efl::Animator const ,  ::efl::File const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::ui::Clickable const ,  ::efl::ui::Scrollable const ,  ::efl::ui::Zoomable const ,  ::elm::Interface_Scrollable const ,  ::elm::Widget const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Action const ,  ::elm::interface::Atspi_Component const ,  ::elm::interface::Atspi_Widget_Action const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Photocam) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Photocam>::value, "");
} 
#include "elm_photocam.eo.impl.hh"
#endif
