#ifndef EFL_CANVAS_OBJECT_EO_HH
#define EFL_CANVAS_OBJECT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace efl { namespace canvas { 
struct Object;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::canvas::Object> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace canvas { 
struct Object {
   ::efl::eolian::return_traits<void>::type type_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type type) const;
   ::efl::eolian::return_traits<Efl_Event_Object_Pointer_Mode>::type pointer_mode_get() const;
   ::efl::eolian::return_traits<void>::type pointer_mode_set( ::efl::eolian::in_traits<Efl_Event_Object_Pointer_Mode>::type pointer_mode) const;
   ::efl::eolian::return_traits<Efl_Gfx_Render_Op>::type render_op_get() const;
   ::efl::eolian::return_traits<void>::type render_op_set( ::efl::eolian::in_traits<Efl_Gfx_Render_Op>::type render_op) const;
   ::efl::eolian::return_traits<bool>::type freeze_events_get() const;
   ::efl::eolian::return_traits<void>::type freeze_events_set( ::efl::eolian::in_traits<bool>::type freeze) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type clip_get() const;
   ::efl::eolian::return_traits<void>::type clip_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type clip) const;
   ::efl::eolian::return_traits<bool>::type repeat_events_get() const;
   ::efl::eolian::return_traits<void>::type repeat_events_set( ::efl::eolian::in_traits<bool>::type repeat) const;
   ::efl::eolian::return_traits<double>::type scale_get() const;
   ::efl::eolian::return_traits<void>::type scale_set( ::efl::eolian::in_traits<double>::type scale) const;
   ::efl::eolian::return_traits<bool>::type key_focus_get() const;
   ::efl::eolian::return_traits<void>::type key_focus_set( ::efl::eolian::in_traits<bool>::type focus) const;
   ::efl::eolian::return_traits<bool>::type is_frame_object_get() const;
   ::efl::eolian::return_traits<void>::type is_frame_object_set( ::efl::eolian::in_traits<bool>::type is_frame) const;
   ::efl::eolian::return_traits<bool>::type precise_is_inside_get() const;
   ::efl::eolian::return_traits<void>::type precise_is_inside_set( ::efl::eolian::in_traits<bool>::type precise) const;
   ::efl::eolian::return_traits<bool>::type propagate_events_get() const;
   ::efl::eolian::return_traits<void>::type propagate_events_set( ::efl::eolian::in_traits<bool>::type propagate) const;
   ::efl::eolian::return_traits<bool>::type pass_events_get() const;
   ::efl::eolian::return_traits<void>::type pass_events_set( ::efl::eolian::in_traits<bool>::type pass) const;
   ::efl::eolian::return_traits<bool>::type anti_alias_get() const;
   ::efl::eolian::return_traits<void>::type anti_alias_set( ::efl::eolian::in_traits<bool>::type anti_alias) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::canvas::Object>>::type clipees_get() const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type render_parent_get() const;
   ::efl::eolian::return_traits<Efl_Text_Bidirectional_Type>::type paragraph_direction_get() const;
   ::efl::eolian::return_traits<void>::type paragraph_direction_set( ::efl::eolian::in_traits<Efl_Text_Bidirectional_Type>::type dir) const;
   ::efl::eolian::return_traits<bool>::type no_render_get() const;
   ::efl::eolian::return_traits<void>::type no_render_set( ::efl::eolian::in_traits<bool>::type enable) const;
   ::efl::eolian::return_traits<void>::type legacy_ctor() const;
   ::efl::eolian::return_traits<bool>::type clipees_has() const;
   ::efl::eolian::return_traits<bool>::type key_grab( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits<Evas_Modifier_Mask>::type modifiers,  ::efl::eolian::in_traits<Evas_Modifier_Mask>::type not_modifiers,  ::efl::eolian::in_traits<bool>::type exclusive) const;
   ::efl::eolian::return_traits<void>::type key_ungrab( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits<Evas_Modifier_Mask>::type modifiers,  ::efl::eolian::in_traits<Evas_Modifier_Mask>::type not_modifiers) const;
   ::efl::eolian::return_traits<void>::type clip_unset() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::canvas::Object() const;
   operator ::efl::canvas::Object&();
   operator ::efl::canvas::Object const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::efl::Animator,  ::efl::Gfx,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace canvas { 
struct Object : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Object( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Object(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Object(Object const& other) = default;
   Object(Object&& other) = default;
   Object& operator=(Object const& other) = default;
   Object& operator=(Object&& other) = default;
   Object()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Object( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Object(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type type_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type type) const;
   ::efl::eolian::return_traits<Efl_Event_Object_Pointer_Mode>::type pointer_mode_get() const;
   ::efl::eolian::return_traits<void>::type pointer_mode_set( ::efl::eolian::in_traits<Efl_Event_Object_Pointer_Mode>::type pointer_mode) const;
   ::efl::eolian::return_traits<Efl_Gfx_Render_Op>::type render_op_get() const;
   ::efl::eolian::return_traits<void>::type render_op_set( ::efl::eolian::in_traits<Efl_Gfx_Render_Op>::type render_op) const;
   ::efl::eolian::return_traits<bool>::type freeze_events_get() const;
   ::efl::eolian::return_traits<void>::type freeze_events_set( ::efl::eolian::in_traits<bool>::type freeze) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type clip_get() const;
   ::efl::eolian::return_traits<void>::type clip_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type clip) const;
   ::efl::eolian::return_traits<bool>::type repeat_events_get() const;
   ::efl::eolian::return_traits<void>::type repeat_events_set( ::efl::eolian::in_traits<bool>::type repeat) const;
   ::efl::eolian::return_traits<double>::type scale_get() const;
   ::efl::eolian::return_traits<void>::type scale_set( ::efl::eolian::in_traits<double>::type scale) const;
   ::efl::eolian::return_traits<bool>::type key_focus_get() const;
   ::efl::eolian::return_traits<void>::type key_focus_set( ::efl::eolian::in_traits<bool>::type focus) const;
   ::efl::eolian::return_traits<bool>::type is_frame_object_get() const;
   ::efl::eolian::return_traits<void>::type is_frame_object_set( ::efl::eolian::in_traits<bool>::type is_frame) const;
   ::efl::eolian::return_traits<bool>::type precise_is_inside_get() const;
   ::efl::eolian::return_traits<void>::type precise_is_inside_set( ::efl::eolian::in_traits<bool>::type precise) const;
   ::efl::eolian::return_traits<bool>::type propagate_events_get() const;
   ::efl::eolian::return_traits<void>::type propagate_events_set( ::efl::eolian::in_traits<bool>::type propagate) const;
   ::efl::eolian::return_traits<bool>::type pass_events_get() const;
   ::efl::eolian::return_traits<void>::type pass_events_set( ::efl::eolian::in_traits<bool>::type pass) const;
   ::efl::eolian::return_traits<bool>::type anti_alias_get() const;
   ::efl::eolian::return_traits<void>::type anti_alias_set( ::efl::eolian::in_traits<bool>::type anti_alias) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::canvas::Object>>::type clipees_get() const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type render_parent_get() const;
   ::efl::eolian::return_traits<Efl_Text_Bidirectional_Type>::type paragraph_direction_get() const;
   ::efl::eolian::return_traits<void>::type paragraph_direction_set( ::efl::eolian::in_traits<Efl_Text_Bidirectional_Type>::type dir) const;
   ::efl::eolian::return_traits<bool>::type no_render_get() const;
   ::efl::eolian::return_traits<void>::type no_render_set( ::efl::eolian::in_traits<bool>::type enable) const;
   ::efl::eolian::return_traits<void>::type legacy_ctor() const;
   ::efl::eolian::return_traits<bool>::type clipees_has() const;
   ::efl::eolian::return_traits<bool>::type key_grab( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits<Evas_Modifier_Mask>::type modifiers,  ::efl::eolian::in_traits<Evas_Modifier_Mask>::type not_modifiers,  ::efl::eolian::in_traits<bool>::type exclusive) const;
   ::efl::eolian::return_traits<void>::type key_ungrab( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits<Evas_Modifier_Mask>::type modifiers,  ::efl::eolian::in_traits<Evas_Modifier_Mask>::type not_modifiers) const;
   ::efl::eolian::return_traits<void>::type clip_unset() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct mouse_in_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_MOUSE_IN; }
      typedef void parameter_type;
   } const mouse_in_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct mouse_out_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_MOUSE_OUT; }
      typedef void parameter_type;
   } const mouse_out_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct mouse_down_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_MOUSE_DOWN; }
      typedef void parameter_type;
   } const mouse_down_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct mouse_up_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_MOUSE_UP; }
      typedef void parameter_type;
   } const mouse_up_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct mouse_move_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_MOUSE_MOVE; }
      typedef void parameter_type;
   } const mouse_move_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct mouse_wheel_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_MOUSE_WHEEL; }
      typedef void parameter_type;
   } const mouse_wheel_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct multi_down_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_MULTI_DOWN; }
      typedef void parameter_type;
   } const multi_down_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct multi_up_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_MULTI_UP; }
      typedef void parameter_type;
   } const multi_up_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct multi_move_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_MULTI_MOVE; }
      typedef void parameter_type;
   } const multi_move_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct free_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_FREE; }
      typedef void parameter_type;
   } const free_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct key_down_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_KEY_DOWN; }
      typedef void parameter_type;
   } const key_down_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct key_up_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_KEY_UP; }
      typedef void parameter_type;
   } const key_up_event;
#endif
   static struct focus_in_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_FOCUS_IN; }
      typedef void parameter_type;
   } const focus_in_event;
   static struct focus_out_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_FOCUS_OUT; }
      typedef void parameter_type;
   } const focus_out_event;
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct del_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_DEL; }
      typedef void parameter_type;
   } const del_event;
#endif
#ifdef EFL_CANVAS_OBJECT_BETA
   static struct hold_event
   {
      static Eo_Event_Description const* description()
      { return EFL_CANVAS_OBJECT_EVENT_HOLD; }
      typedef void parameter_type;
   } const hold_event;
#endif
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::efl::Animator,  ::efl::Gfx,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Object) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Object>::value, "");
} } 
#include "efl_canvas_object.eo.impl.hh"
#endif
