#ifndef EFL_EVENT_KEY_EO_HH
#define EFL_EVENT_KEY_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_event.eo.h"
#include "efl_event_input.eo.h"
#include "efl_event_key.eo.h"
#include "efl_input_device.eo.h"
#include "efl_input_state.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_event.eo.hh"
#include "efl_event_input.eo.hh"
#include "efl_input_device.eo.hh"
#include "efl_input_state.eo.hh"
#include "eo_base.eo.hh"
namespace efl { namespace event { 
struct Key;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::event::Key> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace event { 
struct Key {
   ::efl::eolian::return_traits<bool>::type pressed_get() const;
   ::efl::eolian::return_traits<void>::type pressed_set( ::efl::eolian::in_traits<bool>::type val) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type key_name_get() const;
   ::efl::eolian::return_traits<void>::type key_name_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type val) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type key_get() const;
   ::efl::eolian::return_traits<void>::type key_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type val) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type string_get() const;
   ::efl::eolian::return_traits<void>::type string_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type val) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type compose_get() const;
   ::efl::eolian::return_traits<void>::type compose_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type val) const;
   ::efl::eolian::return_traits<int>::type key_code_get() const;
   ::efl::eolian::return_traits<void>::type key_code_set( ::efl::eolian::in_traits<int>::type val) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_EVENT_KEY_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::event::Key() const;
   operator ::efl::event::Key&();
   operator ::efl::event::Key const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Key,  ::efl::Event,  ::efl::event::Input,  ::efl::input::State,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Key const ,  ::efl::Event const ,  ::efl::event::Input const ,  ::efl::input::State const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace event { 
struct Key : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Event)
   , EO_CXX_INHERIT( ::efl ::event::Input)
   , EO_CXX_INHERIT( ::efl ::input::State)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Key( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Key(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Key(Key const& other) = default;
   Key(Key&& other) = default;
   Key& operator=(Key const& other) = default;
   Key& operator=(Key&& other) = default;
   Key()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Key( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Key(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type pressed_get() const;
   ::efl::eolian::return_traits<void>::type pressed_set( ::efl::eolian::in_traits<bool>::type val) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type key_name_get() const;
   ::efl::eolian::return_traits<void>::type key_name_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type val) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type key_get() const;
   ::efl::eolian::return_traits<void>::type key_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type val) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type string_get() const;
   ::efl::eolian::return_traits<void>::type string_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type val) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type compose_get() const;
   ::efl::eolian::return_traits<void>::type compose_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type val) const;
   ::efl::eolian::return_traits<int>::type key_code_get() const;
   ::efl::eolian::return_traits<void>::type key_code_set( ::efl::eolian::in_traits<int>::type val) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_EVENT_KEY_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Key,  ::efl::Event,  ::efl::event::Input,  ::efl::input::State,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Key const ,  ::efl::Event const ,  ::efl::event::Input const ,  ::efl::input::State const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Key) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Key>::value, "");
} } 
#include "efl_event_key.eo.impl.hh"
#endif
