#ifndef EVAS_CANVAS3D_OBJECT_EO_HH
#define EVAS_CANVAS3D_OBJECT_EO_HH
#include <Eo.h>

extern "C" {
#include "eo_base.eo.h"
#include "evas_canvas3d_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "eo_base.eo.hh"
namespace evas { namespace canvas3d { 
struct Object;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Object> : ::std::true_type {}; } }

namespace eo_cxx {
namespace evas { namespace canvas3d { 
struct Object {
   ::efl::eolian::return_traits<void>::type change( ::efl::eolian::in_traits<Evas_Canvas3D_State>::type state,  ::efl::eolian::in_traits< ::evas::canvas3d::Object>::type ref) const;
   ::efl::eolian::return_traits<Evas_Canvas3D_Object_Type>::type type_get() const;
   ::efl::eolian::return_traits<void>::type type_set( ::efl::eolian::in_traits<Evas_Canvas3D_Object_Type>::type type) const;
   ::efl::eolian::return_traits<bool>::type dirty_get( ::efl::eolian::in_traits<Evas_Canvas3D_State>::type state) const;
   ::efl::eolian::return_traits<void>::type update() const;
   ::efl::eolian::return_traits<void>::type update_notify() const;
   ::efl::eolian::return_traits<void>::type change_notify( ::efl::eolian::in_traits<Evas_Canvas3D_State>::type state,  ::efl::eolian::in_traits< ::evas::canvas3d::Object>::type ref) const;
   ::efl::eolian::return_traits<void>::type callback_register( ::efl::eolian::in_traits< ::efl::eina::string_view>::type event,  ::efl::eolian::in_traits<void const*>::type data) const;
   ::efl::eolian::return_traits<void>::type callback_unregister( ::efl::eolian::in_traits< ::efl::eina::string_view>::type event) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::canvas3d::Object() const;
   operator ::evas::canvas3d::Object&();
   operator ::evas::canvas3d::Object const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace evas { namespace canvas3d { 
struct Object : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Object( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Object(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Object(Object const& other) = default;
   Object(Object&& other) = default;
   Object& operator=(Object const& other) = default;
   Object& operator=(Object&& other) = default;
   Object()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Object( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Object(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type change( ::efl::eolian::in_traits<Evas_Canvas3D_State>::type state,  ::efl::eolian::in_traits< ::evas::canvas3d::Object>::type ref) const;
   ::efl::eolian::return_traits<Evas_Canvas3D_Object_Type>::type type_get() const;
   ::efl::eolian::return_traits<void>::type type_set( ::efl::eolian::in_traits<Evas_Canvas3D_Object_Type>::type type) const;
   ::efl::eolian::return_traits<bool>::type dirty_get( ::efl::eolian::in_traits<Evas_Canvas3D_State>::type state) const;
   ::efl::eolian::return_traits<void>::type update() const;
   ::efl::eolian::return_traits<void>::type update_notify() const;
   ::efl::eolian::return_traits<void>::type change_notify( ::efl::eolian::in_traits<Evas_Canvas3D_State>::type state,  ::efl::eolian::in_traits< ::evas::canvas3d::Object>::type ref) const;
   ::efl::eolian::return_traits<void>::type callback_register( ::efl::eolian::in_traits< ::efl::eina::string_view>::type event,  ::efl::eolian::in_traits<void const*>::type data) const;
   ::efl::eolian::return_traits<void>::type callback_unregister( ::efl::eolian::in_traits< ::efl::eina::string_view>::type event) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct clicked_event
   {
      static Eo_Event_Description const* description()
      { return EVAS_CANVAS3D_OBJECT_EVENT_CLICKED; }
      typedef void parameter_type;
   } const clicked_event;
   static struct collision_event
   {
      static Eo_Event_Description const* description()
      { return EVAS_CANVAS3D_OBJECT_EVENT_COLLISION; }
      typedef void parameter_type;
   } const collision_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Object) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Object>::value, "");
} } 
#include "evas_canvas3d_object.eo.impl.hh"
#endif
