#ifndef EVAS_IMAGE_EO_HH
#define EVAS_IMAGE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_filter_internal.eo.h"
#include "efl_canvas_image_internal.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_file.eo.h"
#include "efl_flipable.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_buffer.eo.h"
#include "efl_gfx_fill.eo.h"
#include "efl_gfx_filter.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_gfx_view.eo.h"
#include "efl_image.eo.h"
#include "efl_input_interface.eo.h"
#include "efl_orientation.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
#include "evas_image.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_filter_internal.eo.hh"
#include "efl_canvas_image_internal.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_file.eo.hh"
#include "efl_flipable.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_buffer.eo.hh"
#include "efl_gfx_fill.eo.hh"
#include "efl_gfx_filter.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_gfx_view.eo.hh"
#include "efl_image.eo.hh"
#include "efl_input_interface.eo.hh"
#include "efl_orientation.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace evas { 
struct Image;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::Image> : ::std::true_type {}; } }

namespace eo_cxx {
namespace evas { 
struct Image {
   static Eo_Class const* _eo_class()
   {
      return EVAS_IMAGE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::Image() const;
   operator ::evas::Image&();
   operator ::evas::Image const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Image,  ::efl::Animator,  ::efl::File,  ::efl::Flipable,  ::efl::Gfx,  ::efl::Image,  ::efl::Orientation,  ::efl::canvas::Object,  ::efl::canvas::filter::Internal,  ::efl::canvas::image::Internal,  ::efl::gfx::Buffer,  ::efl::gfx::Fill,  ::efl::gfx::Filter,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::View,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Image const ,  ::efl::Animator const ,  ::efl::File const ,  ::efl::Flipable const ,  ::efl::Gfx const ,  ::efl::Image const ,  ::efl::Orientation const ,  ::efl::canvas::Object const ,  ::efl::canvas::filter::Internal const ,  ::efl::canvas::image::Internal const ,  ::efl::gfx::Buffer const ,  ::efl::gfx::Fill const ,  ::efl::gfx::Filter const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::View const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace evas { 
struct Image : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::File)
   , EO_CXX_INHERIT( ::efl::Flipable)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl::Image)
   , EO_CXX_INHERIT( ::efl::Orientation)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::canvas ::filter::Internal)
   , EO_CXX_INHERIT( ::efl ::canvas ::image::Internal)
   , EO_CXX_INHERIT( ::efl ::gfx::Buffer)
   , EO_CXX_INHERIT( ::efl ::gfx::Fill)
   , EO_CXX_INHERIT( ::efl ::gfx::Filter)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx::View)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Image( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Image(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Image(Image const& other) = default;
   Image(Image&& other) = default;
   Image& operator=(Image const& other) = default;
   Image& operator=(Image&& other) = default;
   Image()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Image( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Image(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return EVAS_IMAGE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Image,  ::efl::Animator,  ::efl::File,  ::efl::Flipable,  ::efl::Gfx,  ::efl::Image,  ::efl::Orientation,  ::efl::canvas::Object,  ::efl::canvas::filter::Internal,  ::efl::canvas::image::Internal,  ::efl::gfx::Buffer,  ::efl::gfx::Fill,  ::efl::gfx::Filter,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::View,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Image const ,  ::efl::Animator const ,  ::efl::File const ,  ::efl::Flipable const ,  ::efl::Gfx const ,  ::efl::Image const ,  ::efl::Orientation const ,  ::efl::canvas::Object const ,  ::efl::canvas::filter::Internal const ,  ::efl::canvas::image::Internal const ,  ::efl::gfx::Buffer const ,  ::efl::gfx::Fill const ,  ::efl::gfx::Filter const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::View const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Image) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Image>::value, "");
} 
#include "evas_image.eo.impl.hh"
#endif
